"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _paragon = require("@openedx/paragon");
var _icons = require("@openedx/paragon/icons");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const GalleryLoadMoreButton = _ref => {
  let {
    assetCount,
    displayListLength,
    fetchNextPage,
    isLoaded
  } = _ref;
  const [currentPage, setCurrentPage] = (0, _react.useState)(1);
  const handlePageChange = () => {
    fetchNextPage({
      pageNumber: currentPage
    });
    setCurrentPage(currentPage + 1);
  };
  const buttonState = isLoaded ? 'default' : 'pending';
  const buttonProps = {
    labels: {
      default: 'Load more',
      pending: 'Loading'
    },
    icons: {
      default: /*#__PURE__*/(0, _jsxRuntime.jsx)(_paragon.Icon, {
        src: _icons.ExpandMore
      }),
      pending: /*#__PURE__*/(0, _jsxRuntime.jsx)(_paragon.Icon, {
        src: _icons.SpinnerSimple,
        className: "icon-spin"
      })
    },
    disabledStates: ['pending'],
    variant: 'primary'
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: "row justify-content-center py-3",
    children: displayListLength !== assetCount && /*#__PURE__*/(0, _jsxRuntime.jsx)(_paragon.StatefulButton, _objectSpread(_objectSpread({}, buttonProps), {}, {
      onClick: handlePageChange,
      state: buttonState
    }))
  });
};
GalleryLoadMoreButton.propTypes = {
  assetCount: _propTypes.default.number.isRequired,
  displayListLength: _propTypes.default.number.isRequired,
  fetchNextPage: _propTypes.default.func.isRequired,
  currentPage: _propTypes.default.number.isRequired,
  setCurrentPage: _propTypes.default.func.isRequired,
  isLoaded: _propTypes.default.bool.isRequired
};
var _default = exports.default = GalleryLoadMoreButton;
//# sourceMappingURL=GalleryLoadMoreButton.js.map